//double SetpointBits, Input, Output;
int Input, Input2;
int Setpoint, Setpoint2;
int Delta, Delta2;
int outpin = 9;
int outpin2 = 10;
int k = 1;
int pwm, pwm2;
int serialIndex = 0;
int serialValues[2];
float inputVoltage = 20.0;
// Create PID controller
//PID myPID(&Input, &Output, &Setpoint, 5.0, 0.0, 0.0, DIRECT);


void setup() {
  // initialize serial:
  Serial.begin(9600);
  setPwmFrequency(outpin, 1);
  setPwmFrequency(outpin2, 1);
  
  pwm = 255; //default to 0
  pwm2 = 255;
  
  analogWrite(outpin, pwm);
  analogWrite(outpin2, pwm);
  
  Setpoint = 0;
  Setpoint2 = 0;
}

void loop() {
  // SOURCE 1
  Input = analogRead(1);
  //Serial.println(Input);
  Delta = -1*(Setpoint - Input);
  pwm = constrain(pwm+Delta/6,0,1023);  
  analogWrite(outpin, constrain(map(pwm, 0, 1023, 0, 255),0,254));
  
  // SOURCE 2
  Input2 = analogRead(2);
  Delta2 = -1*(Setpoint2 - Input2);
  pwm2 = constrain(pwm2+Delta2/6,0,1023);  
  analogWrite(outpin2, constrain(map(pwm2, 0, 1023, 0, 255),0,254));
}

void serialEvent() {
  if(Serial.available()){
    byte incomingValue = Serial.read();
    serialValues[serialIndex] = int(incomingValue);
    //Serial.println(values[serialIndex]);
    serialIndex++;
    if(serialIndex > 1){ 
      //all data received 
      //serialValues[0] is source, values[1] is desired voltage in range 0 to 1023
      serialIndex = 0;
      if (serialValues[0] == 1){
        Setpoint = int( round( serialValues[1]*1023.0/inputVoltage ) );
      } else if (serialValues[0] == 2){
        Setpoint2 = int( round( serialValues[1]*1023.0/inputVoltage ) ); 
      }
    }
  }
}

void setPwmFrequency(int pin, int divisor) {
 byte mode;
 if(pin == 5 || pin == 6 || pin == 9 || pin == 10) {
   switch(divisor) {
     case 1: mode = 0x01; break;
     case 8: mode = 0x02; break;
     case 64: mode = 0x03; break;
     case 256: mode = 0x04; break;
     case 1024: mode = 0x05; break;
     default: return;
   }
   if(pin == 5 || pin == 6) {
     TCCR0B = TCCR0B & 0b11111000 | mode;
   } else {
     TCCR1B = TCCR1B & 0b11111000 | mode;
   }
 } else if(pin == 3 || pin == 11) {
   switch(divisor) {
     case 1: mode = 0x01; break;
     case 8: mode = 0x02; break;
     case 32: mode = 0x03; break;
     case 64: mode = 0x04; break;
     case 128: mode = 0x05; break;
     case 256: mode = 0x06; break;
     case 1024: mode = 0x7; break;
     default: return;
   }
   TCCR2B = TCCR2B & 0b11111000 | mode;
 }
}
